<?php
/**
* Plugin buddies_links
*
* @package	PLX
* @version	1.0
* @date	16/09/16
* @author Bronco
**/
class buddies_links extends plxPlugin {
	public function __construct($default_lang) {
		# appel du constructeur de la classe plxPlugin (obligatoire)
		parent::__construct($default_lang);

		
		
		# limite l'acces a l'ecran de configuration du plugin
		# PROFIL_ADMIN , PROFIL_MANAGER , PROFIL_MODERATOR , PROFIL_EDITOR , PROFIL_WRITER
		$this->setConfigProfil(PROFIL_ADMIN);
		
		
		# Declaration d'un hook (existant ou nouveau)
		$this->addHook('show_buddies_links','show_buddies_links');

		
	}

	# Activation / desactivation
	public function OnActivate() {
		# code à executer à l’activation du plugin
	}
	public function OnDeactivate() {
		# code à executer à la désactivation du plugin
	}
	

	########################################
	# HOOKS
	########################################


	########################################
	# show_buddies_links
	########################################
	# Description:
	public function show_buddies_links(){
		$names 			=array_filter(explode('|',$this->getParam("name")));
		$links 			=array_filter(explode('|',$this->getParam("link")));
		$descriptions 	=array_filter(explode('|',$this->getParam("description")));
		$desc			=$this->getParam("desc_in_title");
		$ordered 		=array();
		foreach ($names as $key => $name){
			$ordered[$name]['link']=$links[$key];
			$ordered[$name]['description']=$descriptions[$key];
		}
		ksort($ordered);
		if (!empty($this->getParam("icon_size"))){
			echo '<style>.buddies_links img{width:'.$this->getParam("icon_size").'px;height:'.$this->getParam("icon_size").'px;}</style>';
		}
		echo '<h3>'.$this->getParam("links_title").'</h3>';
		echo '<ul class="buddies_links unstyled-list">';
		foreach ($ordered as $name => $value) {
			if (empty($desc)){
				$title=$value['description'];
				$desc ='';
			}else{
				$title='';
				$desc =$value['description'];
			}
			echo '
				<li>
					<a href="'.$value['link'].'" title="'.$title.'">';
						if (!empty($this->getParam("icon_size"))){
							echo '<img src="'.$this->get_favicon($value['link']).'" alt="favicon"/> ';
						}
					echo $name.'</a>
					<span>'.$desc.'</span>
				</li>
			';
		}
		echo '</ul>';
	}

	########################################
	# curlTo($target_folder)
	########################################
	# Description:
	function curlFile($url){
	    // create curl resource
	    $ch = curl_init();

	    // set url
	    curl_setopt($ch, CURLOPT_URL, $url);

	    //return the transfer as a string
	    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	    curl_setopt($ch,CURLOPT_USERAGENT,'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.8.1.13) Gecko/20080311 Firefox/2.0.0.13');

	    // $output contains the output string
	    $output = curl_exec($ch);

	    // close curl resource to free up system resources
	    curl_close($ch); 
	    return $output;
	}  
  
	# addSlash
	###########################
	# add a slash if needed
	## $string as string
	## Return : string
	public function addSlash($string){
		if (substr($string,strlen($string)-1,1)!='/'&&!empty($string)){return $string.'/';}else{return $string;}
	} 

	private function get_favicon($url){ 
		$defaultfavicon=PLX_PLUGINS.'buddies_links/favicons/default_favicon.png';     
        $id=sha1($url);
        $file=PLX_PLUGINS.'buddies_links/favicons/'.$id.'.png';
        if ($this->getParam("download_icons")!='1'){return $defaultfavicon;}     
        if (!is_file($file)){//exit($file);
        	if ($url==''){return $defaultfavicon;}     
        
        	// tentative de chargement du header de la page
	        @$page_header=file_get_contents($url, NULL, NULL, 0, 15000);
	        if (empty($page_header)){@$page_header=$this->curlFile($url);} 

	        // si on a un header
	        if (!empty($page_header)){ 
	        	// on cherche la favicon
	        	$regex=[
	        		'#<link[^^]*?href=["\'](?P<path>.*?(?P<ext>\.png|\.ico|\.gif).*?)["\']#i',
	        		'#rel=["\'].*?icon.*?href=["\'](?P<path>.*?(?P<ext>\.png|\.ico|\.gif).*?)"#i',
	        		'#href=["\'](?P<path>.*?(?P<ext>\.png|\.ico|\.gif).*?)"[^>]*?rel=["\'][^"\']*?icon#i',
	        		'#rel=["\'][ \-]*?icon.*?href=["\'](?P<path>[^"\']+)#i',
	        		'#href=["\'](?P<path>[^"\']+)[^>]*?rel=["\'][^"\']*?icon#i',
	        	];
	        	foreach($regex as $rgx){
	        		$flag=preg_match($rgx,$page_header,$r) ;
	        		if (!empty($flag)){
	        			$f=$r['path'];
	        			break;
	        		}
	        	}
	        	
	        	$flag=false;
		        if (!empty($f)){
		        	$parsed=parse_url($url);
		        	$urls=[
		        		$f,
		        		$this->addSlash($url).$f,
		        		$this->addSlash(pathinfo($url ,PATHINFO_DIRNAME )).$f,
		        		$this->addSlash($parsed['scheme'].'://'.$parsed['host']).$f,
		        	];
			        foreach ($urls as $i=>$favlink) {
		        		@$img=file_get_contents($favlink);
		        		if(!empty($img) && stripos($img,'html')===false && stripos($img,'html')===false){
		        			$flag=true;
		        			break;
		        		}
		        	}

		        } 
		       		        
		    }

			if (!$flag){   			        	              
				$img=file_get_contents($defaultfavicon);
			} 
		    file_put_contents($file,$img);    
	    }
	        
	    
	    return $file;
	}

}





/* Pense-bete:
 * Récuperer des parametres du fichier parameters.xml
 *	$this->getParam("<nom du parametre>")
 *	$this-> setParam ("param1", 12345, "numeric")
 *	$this->saveParams()
 *
 *	plxUtils::strCheck($string) : sanitize string
 *
 * 
 * Quelques constantes utiles: 
 * PLX_CORE
 * PLX_ROOT
 * PLX_CHARSET
 * PLX_CONFIG_PATH
 * PLX_PLUGINS
 * PLX_CONFIG_PATH
 * PLX_ADMIN (true si on est dans admin)
 * PLX_CHARSET
 * PLX_VERSION
 * PLX_FEED
 *
 * Appel de HOOK dans un thème
 *	eval($plxShow->callHook("ThemeEndHead","param1"))  ou eval($plxShow->callHook("ThemeEndHead",array("param1","param2")))
 *	ou $retour=$plxShow->callHook("ThemeEndHead","param1"));
 */